<template>
  <div class="home-warp">
    <div class="home">
      <audio ref="audioPlayer" :autoplay="playState.kuwo">
        <source src="../assets/audio/music.mp3" type="audio/mpeg">
      </audio>
      <img src="../assets/images/home/bk.webp" alt="" class="home-img" />

      <div class="weather-warp"  v-show="currentPageIndex !== 0" :style="{ opacity: per }" >
        <div class="weather-click-warp">
          <div class="left" @click="showLanguageAssistant">{{ currentPageIndex }}</div>
          <div class="mid" @click="showWeather"></div>
          <div class="right" @click="showKuWo"></div>
        </div>
        <img
          src="../assets/images/home/weather.webp"
          alt=""
          class="weather-img"
        />
      </div>

      <div
        class="mouse-wheel-horizontal-slide"
        :style="slideZIndex ? 'z-index: 11;' : ''"
      >
        <div class="slide-container">
          <div class="slide-wrapper" ref="slide">
            <div class="slide-content">
              <div class="slide-page page1">
                <img src="../assets/images/page1.webp" alt="" class="page-one" />
              </div>
              <div class="slide-page page2">
                <div class="music-warp">
                  <div class="music-item" @click="showKuWo">
                    <div class="music-name">
                      <svg-icon iconClass="home_kuwomusic" class="music-svg" />
                      <span>酷我音乐</span>
                    </div>
                    <div class="music-play">
                      <div class="music-play-left">
                        <svg-icon
                          iconClass="home_left"
                          class="home_left"
                        ></svg-icon>
                      </div>
                      <div class="music-play-mid">
                        <div
                            class="music-play-mid-warp"
                            @click.stop="changePlayState('kuwo')"
                        >
                          <svg-icon
                              :iconClass="playState.kuwo ? 'home_bof' : 'home_zant'"
                              :class="playState.kuwo ? 'home_bof' : 'home_zant'"
                          />
                        </div>
                        <img
                            src="../assets/images/home/music.webp"
                            alt=""
                            srcset=""
                            style="border-radius: 50%;"
                        />
                      </div>
                      <div class="music-play-right">
                        <svg-icon
                          iconClass="home_right"
                          class="home_right"
                        ></svg-icon>
                      </div>
                    </div>
                    <div class="music-palyName">Slowly Drifting Away</div>
                  </div>
                  <div class="music-item" @click="showMap">
                    <div class="music-name">
                      <svg-icon
                        iconClass="home_gd"
                        class="music-svg"
                      ></svg-icon>
                      <span>高德地图定制版</span>
                    </div>
                    <div class="music-play">
                      <div class="music-play-mid">
                        <img
                          src="../assets/images/home/bg2.webp"
                          alt=""
                          srcset=""
                        />
                      </div>
                    </div>
                  </div>
                  <div class="music-item" @click="showXiMa">
                    <div class="music-name">
                      <svg-icon
                        iconClass="home_ting"
                        class="music-svg"
                      ></svg-icon>
                      <span>喜马拉雅</span>
                    </div>
                    <div class="music-play">
                      <div class="music-play-left">
                        <svg-icon
                          iconClass="home_left"
                          class="home_left"
                        ></svg-icon>
                      </div>
                      <div class="music-play-mid">
                        <div
                          class="music-play-mid-warp"
                          @click.stop="changePlayState('xima')"
                        >
                          <svg-icon
                            iconClass="home_bof"
                            class="home_bof"
                            v-if="playState.xima"
                          ></svg-icon>
                          <svg-icon
                            iconClass="home_zant"
                            class="home_zant"
                            v-else
                          ></svg-icon>
                        </div>
                        <img
                          src="../assets/images/home/bg3.webp"
                          alt=""
                          srcset=""
                        />
                      </div>
                      <div class="music-play-right">
                        <svg-icon
                          iconClass="home_right"
                          class="home_right"
                        ></svg-icon>
                      </div>
                    </div>
                    <div class="music-palyName">卡塔尔小王子入...</div>
                  </div>
                </div>
              </div>
              <!-- 第三页 -->
              <div class="slide-page page3">
                <page-three></page-three>
              </div>
              <div class="slide-page page4" ref="pagefour">
                <page-four @handlePageFour="handlePageFour"></page-four>
              </div>
            </div>
          </div>

          <div class="dots-wrapper" :style="{ opacity: per }">
            <span
              class="dot"
              v-for="(item, index) in 4"
              :key="index"
              :class="{ active: currentPageIndex == index }"
            ></span>
          </div>
        </div>
      </div>

      <div class="conditioner" :style="{ opacity: per }" v-show="currentPageIndex !== 0" >
        <div class="svg-car-warp" @click="showSetting">
          <svg-icon iconClass="home_car" class="home_car"></svg-icon>
        </div>
        <div class="max-left" v-if="showFeng.bottom">
          <TempModel
            ref="temp1"
            class="temp-model1"
            @getTemperature="getLeftTemperature"
            v-show="showFeng.top"
          ></TempModel>
          <template v-if="showFeng.bottom">
            <svg-icon iconClass="home_left2" class="home_left2"></svg-icon>
            <div class="click-div1" @click="addTemp(1)"></div>
            <div class="max-left-number" @click="changeFengTop(1)">
              {{ leftTemperature
              }}<span v-if="leftTemperature != 'Lo' && leftTemperature != 'Hi'"
                >℃</span
              >
            </div>
            <div class="click-div2" @click="reduceTemp(1)"></div>
            <svg-icon iconClass="home_right2" class="home_right2"></svg-icon>
          </template>
        </div>
        <div class="svg-warp">
          <div
            class="left"
            :class="showFeng.bottom ? 'active' : ''"
            @click="changeFeng"
          >
            <svg-icon iconClass="home_off" class="home_off"></svg-icon>
            <span v-if="!showFeng.bottom">关</span>
            <span v-else>开</span>
          </div>
          <div class="mid" @click="showAir">
            <svg-icon iconClass="home_feng" class="home_feng"></svg-icon>
          </div>
          <div class="right">
            <svg-icon iconClass="home_front" class="home_front"></svg-icon>
            <span>前</span>
          </div>
        </div>
        <div class="max-left max-right" v-if="showFengRight.bottom">
          <TempModel
            ref="temp2"
            class="temp-model2"
            @getTemperature="getRightTemperature"
            v-show="showFengRight.top"
          ></TempModel>
          <template v-if="showFengRight.bottom">
            <svg-icon iconClass="home_left2" class="home_left2"></svg-icon>
            <div class="click-div1" @click="addTemp(2)"></div>
            <div class="max-left-number" @click="changeFengTop(2)">
              {{ rightTemperature
              }}<span
                v-if="rightTemperature != 'Lo' && rightTemperature != 'Hi'"
                >℃</span
              >
            </div>
            <div class="click-div2" @click="reduceTemp(2)"></div>
            <svg-icon iconClass="home_right2" class="home_right2"></svg-icon>
          </template>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState } from "vuex";
import BScroll, { Slide, MouseWheel } from "better-scroll";
import TempModel from "@/components/TempModel.vue";
import pageFour from "./page/pageFour.vue";
import pageThree from "@/views/pageThree/index.vue";

BScroll.use(Slide);
BScroll.use(MouseWheel);

export default {
  name: "HomeView",
  components: { TempModel, pageFour, pageThree },
  data() {
    return {
      playState: {
        kuwo: false,
        xima: false,
      },
      showFeng: {
        top: false,
        bottom: false,
      },
      showFengRight: {
        top: false,
        bottom: false,
      },

      leftTemperature: "22",
      rightTemperature: "22",
      //轮播图索引
      currentPageIndex: 1,
      per: 1,
      slideZIndex: false,
    };
  },

  methods: {
    handlePageFour(val) {
      this.slideZIndex = val;
      if (this.slideZIndex) {
        this.showFeng.top = false;
        this.showFengRight.top = false;
        this.leftTemperature = "22";
        this.rightTemperature = "22";
        this.showFeng.bottom = false;
        this.showFengRight.bottom = false;
      }
    },
    changeFeng() {
      //显示温度
      console.log(this.showFeng);
      this.showFeng.bottom = !this.showFeng.bottom;
      this.showFengRight.bottom = !this.showFengRight.bottom;
      if (!this.showFeng.bottom) {
        this.showFeng.top = false;
        this.showFengRight.top = false;
        this.leftTemperature = "22";
        this.rightTemperature = "22";
      }
      // this.leftTemperature = "22";
      // this.rightTemperature = "22";
    },
    addTemp(index) {
      if (index == 1) {
        this.$refs.temp1.clickChange("left");
      } else {
        this.$refs.temp2.clickChange("left");
      }
    },
    reduceTemp(index) {
      console.log("点击");
      if (index == 1) {
        this.$refs.temp1.clickChange("right");
      } else {
        this.$refs.temp2.clickChange("right");
      }
    },
    changeFengTop(index) {
      if (index == 1) {
        this.showFeng.top = !this.showFeng.top;
      } else {
        this.showFengRight.top = !this.showFengRight.top;
      }
      console.log(this.showFeng);
    },
    showXiMa() {
      console.log("显示喜玛拉");
      this.$router.push("/xima");
      this.$store.commit("bottom/changeTopLine", false);
      this.$store.commit("bottom/changeSilde", true);
      this.$store.commit("header/changeHeaderHidden", true);
    },
    showLanguageAssistant() {
      console.log("显示语言助手");
      this.$router.push("/assistant");
      this.$store.commit("bottom/changeTopLine", false);
      this.$store.commit("bottom/changeSilde", true);
    },
    showWeather() {
      console.log("显示天气");
      this.$router.push("/staticWeather");
      this.$store.commit("bottom/changeBottomBg", true);
      this.$store.commit("bottom/changeSilde", true);
      this.$store.commit("header/changeHeaderDark", true);
    },
    showKuWo() {
      this.$router.push("/kmusic");
      console.log("显示酷我音乐");
      this.$store.commit("bottom/changeBottomBg", true);
      this.$store.commit("bottom/changeSilde", true);
      this.$store.commit("header/changeHeaderDark", true);
    },
    showAir() {
      console.log("打开空调");
      this.$router.push("/airconditioner");
      this.$store.commit("bottom/changeTopLine", false);
    },
    showMap() {
      console.log("显示地图");
      this.$router.push("/map");
      this.$store.commit("bottom/changeBottomBg", true);
      this.$store.commit("bottom/changeSilde", true);
      this.$store.commit("header/changeHeaderDark", true);
    },
    showSetting() {
      console.log("显示设置");
      this.$router.push("/setting");
      this.$store.commit("bottom/changeSilde", true);
      this.$store.commit("bottom/changeTopLine", false);
    },
    changePlayState(index) {
      //改变播放状态
      this.playState[index] = !this.playState[index];
      if (index === 'kuwo') {
        const audio = this.$refs.audioPlayer;
        if (this.playState[index]) audio.play();
        else audio.pause()
      }
      for (let i in this.playState) {
        if (i !== index) {
          this.playState[i] = false;
        }
      }
    },
    getLeftTemperature(data) {
      this.leftTemperature = data;
    },
    getRightTemperature(data) {
      this.rightTemperature = data;
    },
    //轮播图
    init() {
      this.slide = new BScroll(this.$refs.slide, {
        click: true,
        probeType: 2,
        scrollX: true,
        scrollY: false,
        slide: {
          loop: false,
          threshold: 100,
          autoplay: false,
          startPageXIndex: this.swiperIndex,
        },
        useTransition: false,
        momentum: false,
        bounce: false,
        stopPropagation: true,
        mouseWheel: {
          speed: 2,
          invert: false,
          easeTime: 300,
        },
        quadrant: 2,
      });
      this.slide.getCurrentPage().x = -300;
      this.slide.on("scrollEnd", this._onScrollEnd);
      this.slide.on("slideWillChange", (page) => {
        this.currentPageIndex = page.pageY;
      });

      // v2.1.0
      this.slide.on("slidePageChanged", (page) => {
        if (page.pageX === 0) {
          this.per = 0;
        } else {
          this.per = 1;
        }
      });
      this.slide.on("scroll", (position) => {
        const percentage = position.x / -1201;
        if (position.x >= -1201) {
          this.per = percentage;
        }
      });
    },

    _onScrollEnd(data) {
      if (data.x < 0) {
        this.per = 1;
      }
      let pageIndex = this.slide.getCurrentPage().pageX;
      this.$store.commit("bottom/changeSwiperIndex", pageIndex);
      this.currentPageIndex = pageIndex;
    },
  },
  mounted() {
    this.init();
    this.currentPageIndex = this.swiperIndex;
    console.log("首页加载");
    this.$store.commit("bottom/changeTopLine", true);
    this.$store.commit("bottom/changeSilde", false);
    this.$store.commit("bottom/changeBottomBg", false);
    this.$store.commit("bottom/changeBottomBgW", false);
    this.$store.commit("header/changeHeaderDark", false);
    this.$store.commit("header/changeHeaderHidden", false);
  },
  computed: {
    ...mapState("header", {
      showMask: (state) => state.showMask,
    }),
    ...mapState("bottom", {
      swiperIndex: (state) => state.swiperIndex,
    }),
  },

  //轮播图
  beforeDestroy() {
    this.slide.destroy();
  },
};
</script>



<style scoped lang="scss">
.disableClick{
  pointer-events: none;
}
.home-warp {
  width: 100%;
  height: 100%;
}

.home {
  overflow: hidden;
  width: 100%;
  height: 100%;
  padding: 46px 0 88px;
  background: linear-gradient(180deg, #e8f0f7 0%, #e8f0f7 45%, #deedf4 100%);
  box-sizing: border-box;
  display: flex;
  flex-direction: column;
  align-items: center;

  .home-img {
    z-index: 0;
    opacity: 0.5;
    position: absolute;
    bottom: 0;
    width: 1920px;
    height: 374px;
  }
}

.weather-warp {
  z-index: 10;
  position: absolute;
  width: 1800px;
  height: 139px;
  background: #eef4f8;
  border-radius: 70px 70px 70px 70px;
  top: 124px;
  display: flex;
  justify-content: center;
  align-items: center;

  .weather-img {
    width: 1668px;
    height: 97px;
  }

  .weather-click-warp {
    width: 1668px;
    height: 97px;
    position: absolute;
    background: transparent;
    display: flex;
    justify-content: space-between;

    .left {
      height: 97px;
      width: 371px;
      background: transparent;
    }

    .mid {
      height: 97px;
      width: 200px;
      background: transparent;
      margin-right: 110px;
    }

    .right {
      height: 97px;
      width: 253px;
      background: transparent;
    }
  }
}

.music-warp {
  overflow: hidden;
  position: absolute;
  top: 267px;
  width: 1600px;
  display: flex;
  justify-content: space-between;

  .music-item {
    width: 448px;
    height: 448px;
    background: linear-gradient(180deg, #cbd9f8 0%, #f0f2f7 100%);
    opacity: 1;
    border-radius: 50%;
    border: 10px solid #ffffff;
    box-sizing: border-box;
    display: flex;
    flex-direction: column;
    align-items: center;

    .music-name {
      margin-top: 50px;
      font-size: 28px;
      font-weight: 700;
      color: #151617;
      line-height: 42px;
      display: flex;
      align-items: center;

      .music-svg {
        width: 42px;
        height: 42px;
        margin-right: 6px;
      }
    }

    .music-play {
      margin-top: 25px;
      display: flex;
      align-items: center;

      .music-play-left {
        width: 74px;
        height: 74px;
        background: #a3a5b1;
        opacity: 0.6;
        display: flex;
        align-items: center;
        justify-content: center;
        margin-right: 11px;
        border-radius: 50%;

        .home_left {
          width: 42px;
          height: 52px;
        }
      }

      .music-play-mid {
        display: flex;
        align-items: center;
        justify-content: center;
        width: 216px;
        height: 216px;
        opacity: 1;
        border: 10px solid #c0c9df;
        box-sizing: border-box;
        border-radius: 50%;
        position: relative;

        img {
          position: absolute;
          width: 100%;
          height: auto;
          z-index: 1;
        }

        .music-play-mid-warp {
          width: 100px;
          height: 100px;
          background: rgba(154, 161, 176, 0.5);
          border-radius: 50%;
          z-index: 2;
          display: flex;
          align-items: center;
          justify-content: center;
        }

        .home_bof {
          width: 35px;
          height: 52px;
          position: absolute;
          z-index: 3;
        }

        .home_zant {
          width: 59px;
          height: 72px;
          position: absolute;
          z-index: 3;
        }
      }

      .music-play-right {
        display: flex;
        align-items: center;
        justify-content: center;
        width: 74px;
        height: 74px;
        background: #a3a5b1;
        opacity: 0.6;
        margin-left: 11px;
        border-radius: 50%;

        .home_right {
          width: 42px;
          height: 52px;
        }
      }
    }

    .music-palyName {
      margin-top: 31px;
      font-size: 28px;
      font-weight: 700;
      color: #151617;
      line-height: 42px;
      width: 225px;
      white-space: nowrap;
      overflow: hidden;
      text-overflow: ellipsis;
      text-align: center;
    }
  }
}

.conditioner {
  z-index: 1;
  top: 887px;
  width: 100%;
  display: flex;
  justify-content: center;
  position: absolute;
  align-items: center;

  .max-left {
    width: 229px;
    height: 60px;
    background: #e3f4fa;
    border-radius: 30px 30px 30px 30px;
    padding: 0 26px 0 27px;
    box-sizing: border-box;
    position: absolute;
    left: 347px;
    display: flex;
    align-items: center;
    justify-content: space-between;
    color: #0194f5;
    .home_left2 {
      width: 12px;
      height: 23px;
    }
    .click-div1 {
      width: 60px;
      height: 60px;
      position: absolute;
      background: transparent;
      right: 0;
    }
    .click-div2 {
      width: 60px;
      height: 60px;
      position: absolute;
      background: transparent;
      left: 0;
      bottom: 0;
    }
    .max-left-number {
      font-size: 48px;
      font-weight: 500;
      color: #0194f5;
      span {
        font-size: 30px;
        font-weight: 500;
        color: #0194f5;
      }
    }

    .home_right2 {
      width: 12px;
      height: 23px;
    }

    .temp-model1 {
      position: absolute;
      right: -300px;
      bottom: 129px;
      z-index: 10;
    }

    .temp-model2 {
      position: absolute;
      left: -300px;
      bottom: 129px;
      z-index: 10;
    }
  }
  .max-right {
    left: 1296px;
  }

  .svg-warp {
    width: 518px;
    display: flex;
    justify-content: space-between;
    font-size: 20px;
    font-weight: 400;
    color: #3d3d3d;
    line-height: 30px;
    align-items: center;

    span {
      margin-top: 30px;
      font-size: 20px;
      line-height: 30px;
    }

    .left {
      width: 94px;
      height: 62px;
      background: rgba(246, 247, 247, 0.5);
      border-radius: 40px 40px 40px 40px;
      display: flex;
      align-items: center;
      justify-content: center;

      .home_off {
        width: 48px;
        height: 51px;
      }
    }

    .active {
      color: #4192ee;

      .home_off {
        color: #4192ee;
      }
    }

    .mid {
      .home_feng {
        width: 85px;
        height: 85px;
      }
    }

    .right {
      width: 94px;
      height: 62px;
      background: rgba(246, 247, 247, 0.5);
      border-radius: 40px 40px 40px 40px;
      display: flex;
      align-items: center;
      justify-content: center;

      .home_front {
        width: 53px;
        height: 40px;
      }
    }
  }

  .svg-car-warp {
    width: 128px;
    height: 77px;
    background: rgba(246, 247, 247, 0.5);
    border-radius: 40px 40px 40px 40px;
    position: absolute;
    left: 20px;
    display: flex;
    align-items: center;
    justify-content: center;

    .home_car {
      width: 50px;
      height: 34px;
    }
  }
}

.mouse-wheel-horizontal-slide {
  z-index: 0;
  position: absolute;
  width: 1920px;
  height: 1025px;
  top: 50px;

  .slide-container {
    position: relative;
  }

  .slide-wrapper {
    min-height: 1px;
    overflow: hidden;
  }

  .slide-content {
    white-space: nowrap;
    font-size: 0;
    transform: translateX(0px) translateY(0px) translateZ(1px);
    .slide-page {
      display: inline-block;
      width: 100%;

      text-align: center;
      font-size: 26px;

      &.page1 {
        box-sizing: border-box;
        width: 1600px;
        height: 1025px;
        z-index: 1;
      }

      &.page2 {
        box-sizing: border-box;
        padding-left: 160px;
        width: 1600px;
      }

      &.page3 {
        box-sizing: border-box;
        height: 1025px;
        width: 1600px;
      }

      &.page4 {
        box-sizing: border-box;
        // position: relative;
        // width: 1600px;
        height: 1025px;
      }
    }
  }

  .dots-wrapper {
    z-index: -1;
    top: 760px;
    position: absolute;
    bottom: 4px;
    left: 50%;
    transform: translateX(-50%);

    .dot {
      display: inline-block;
      margin: 0 4px;
      width: 16px;
      height: 16px;
      border-radius: 50%;
      background: #ffffff;

      &.active {
        border-radius: 8px;
        background-color: #3d3d3d;
      }
    }
  }
}

.page-swipper {
  position: absolute;
  width: 1000px;
  height: 1000px;
  background: white;
}

.page-one {
  position: absolute;
  width: 1799px;
  object-fit: contain;
  left: 88px;
  padding-top: 11px;
}

.page-three {
  width: 1600px;
  position: absolute;
  top: 25%;
  left: 50%;
  transform: translateX(-50%);
}

.page-four {
  width: 1600px;
  position: absolute;
  top: 25%;
  left: 50%;
  transform: translateX(-50%);
}

.v-enter-active,
.v-leave-active {
  transition: opacity 0.6s ease;
}

.v-enter-from,
.v-leave-to {
  opacity: 0;
}
</style>
